// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && i1 === 0 && s1.last == len) {
    var s = s1.bytes;
    if (s !== null)
      s2.bytes += s1.bytes;
    else
      s2.bytes += s1.getBytes();
    s2.last += len;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] == (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] == (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] == (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:6, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  return caml_finish_formatting(f, s);
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
var caml_global_data = [0];
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_sys_random_seed () {
  return new Date()^0xffffffff*Math.random();
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function(){function F(d2,d3){return d2.length==1?d2(d3):caml_call_gen(d2,[d3]);}var a=[0,new MlString("Invalid_argument")],b=[0,new MlString("Assert_failure")];caml_register_global(5,[0,new MlString("Division_by_zero")]);caml_register_global(3,a);caml_register_global(2,[0,new MlString("Failure")]);var x=new MlString("%d"),w=new MlString("Pervasives.do_at_exit"),v=new MlString("Random.int"),u=new MlString("x"),t=[0,2061652523,1569539636,364182224,414272206,318284740,2064149575,383018966,1344115143,840823159,1098301843,536292337,1586008329,189156120,1803991420,1217518152,51606627,1213908385,366354223,2077152089,1774305586,2055632494,913149062,526082594,2095166879,784300257,1741495174,1703886275,2023391636,1122288716,1489256317,258888527,511570777,1163725694,283659902,308386020,1316430539,1556012584,1938930020,2101405994,1280938813,193777847,1693450012,671350186,149669678,1330785842,1161400028,558145612,1257192637,1101874969,1975074006,710253903,1584387944,1726119734,409934019,801085050],s=[0,new MlString("src/core/lwt.ml"),440,20],r=[0,new MlString("src/core/lwt.ml"),443,8],q=new MlString("Lwt.fast_connect"),p=new MlString("Lwt.connect"),o=new MlString("Lwt.wakeup"),n=new MlString("Lwt.Canceled"),m=new MlString("canvas"),l=new MlString("2d"),k=new MlString("Dom_html.Canvas_not_available"),j=new MlString("copy"),i=new MlString("lighter"),h=new MlString("source-over"),g=new MlString("#a8a8f6"),f=new MlString("#d9d9d9"),e=new MlString("#767676");function d(c){throw [0,a,c];}function C(B){var y=caml_ml_out_channels_list(0);for(;;){if(y){var z=y[2];try {}catch(A){}var y=z;continue;}return 0;}}caml_register_named_value(w,C);function L(D,E){if(0===D)return [0];var G=caml_make_vect(D,F(E,0)),H=1,I=D-1|0;if(!(I<H)){var J=H;for(;;){G[J+1]=F(E,J);var K=J+1|0;if(I!==J){var J=K;continue;}break;}}return G;}var N=caml_sys_get_config(0)[2],M=[0,0];function aj(U,O){var P=caml_equal(O,[0])?[0,0]:O,Q=P.length-1,R=0,S=54;if(!(S<R)){var T=R;for(;;){caml_array_set(U[1],T,T);var V=T+1|0;if(S!==T){var T=V;continue;}break;}}var W=[0,u],X=0,Y=55,Z=caml_greaterequal(Y,Q)?Y:Q,_=54+Z|0;if(!(_<X)){var $=X;for(;;){var aa=$%55|0,ac=caml_array_get(P,caml_mod($,Q)),ab=W[1],ad=caml_format_int(x,ac),ae=ab.getLen(),af=ad.getLen(),ag=caml_create_string(ae+af|0);caml_blit_string(ab,0,ag,0,ae);caml_blit_string(ad,0,ag,ae,af);W[1]=caml_md5_string(ag,0,ag.getLen());var ah=W[1];caml_array_set(U[1],aa,caml_array_get(U[1],aa)^(((ah.safeGet(0)+(ah.safeGet(1)<<8)|0)+(ah.safeGet(2)<<16)|0)+(ah.safeGet(3)<<24)|0));var ai=$+1|0;if(_!==$){var $=ai;continue;}break;}}U[2]=0;return 0;}32===N;var ak=[0,t.slice(),0];function ar(al){if(1073741823<al||!(0<al))var am=0;else for(;;){ak[2]=(ak[2]+1|0)%55|0;var an=caml_array_get(ak[1],(ak[2]+24|0)%55|0)+(caml_array_get(ak[1],ak[2])^caml_array_get(ak[1],ak[2])>>>25&31)|0;caml_array_set(ak[1],ak[2],an);var ao=an&1073741823,ap=caml_mod(ao,al);if(((1073741823-al|0)+1|0)<(ao-ap|0))continue;var aq=ap,am=1;break;}if(!am)var aq=d(v);return aq;}function au(at){var as=[];caml_update_dummy(as,[0,as,as]);return as;}var av=[0,n],aw=[0,0],aC=42;function aA(ax){var ay=ax[1];{if(3===ay[0]){var az=ay[1],aB=aA(az);if(aB!==az)ax[1]=[3,aB];return aB;}return ax;}}function aE(aD){return aA(aD);}function aX(aF,aK){var aH=aw[1],aG=aF,aI=0;for(;;){if(typeof aG==="number"){if(aI){var aW=aI[2],aV=aI[1],aG=aV,aI=aW;continue;}}else switch(aG[0]){case 1:var aJ=aG[1];if(aI){var aM=aI[2],aL=aI[1];F(aJ,aK);var aG=aL,aI=aM;continue;}F(aJ,aK);break;case 2:var aN=aG[1],aO=[0,aG[2],aI],aG=aN,aI=aO;continue;default:var aP=aG[1][1];if(aP){var aQ=aP[1];if(aI){var aS=aI[2],aR=aI[1];F(aQ,aK);var aG=aR,aI=aS;continue;}F(aQ,aK);}else if(aI){var aU=aI[2],aT=aI[1],aG=aT,aI=aU;continue;}}aw[1]=aH;return 0;}}function a4(aY,a1){var aZ=aA(aY),a0=aZ[1];switch(a0[0]){case 1:if(a0[1][1]===av)return 0;break;case 2:var a3=a0[1][2],a2=[0,a1];aZ[1]=a2;return aX(a3,a2);default:}return d(o);}function a7(a5,a6){return typeof a5==="number"?a6:typeof a6==="number"?a5:[2,a5,a6];}function a9(a8){if(typeof a8!=="number")switch(a8[0]){case 2:var a_=a8[1],a$=a9(a8[2]);return a7(a9(a_),a$);case 1:break;default:if(!a8[1][1])return 0;}return a8;}function bb(ba){return [0,[1,ba]];}function bf(bc,bd){var be=typeof bc[2]==="number"?[1,bd]:[2,[1,bd],bc[2]];bc[2]=be;return 0;}aj([0,caml_make_vect(55,0),0],[0]);var bi=[0,function(bg){return 0;}],bh=au(0),bk=[0,0];function bp(bn){if(bh[2]===bh)return 0;var bj=au(0);bj[1][2]=bh[2];bh[2][1]=bj[1];bj[1]=bh[1];bh[1][2]=bj;bh[1]=bh;bh[2]=bh;bk[1]=0;var bl=bj[2];for(;;){if(bl!==bj){if(bl[4])a4(bl[3],0);var bm=bl[2],bl=bm;continue;}return 0;}}var bo=undefined,bt=null,bs=false,br=Array;M[1]=[0,function(bq){return bq instanceof br?0:[0,new MlWrappedString(bq.toString())];},M[1]];var bu=l.toString(),bv=window,bw=[0,k];window.HTMLElement===bo;bi[1]=function(bx){return 1===bx?(bv.setTimeout(caml_js_wrap_callback(bp),0),0):0;};var by=12,bz=20,bA=Math.floor(bz*Math.sqrt(3)/2+0.5);aj(ak,[0,caml_sys_random_seed(0)]);function bM(bL,bB,bE,bG){var bC=bB<0?1:0;if(bC)var bD=bC;else{var bF=bE<0?1:0;if(bF)var bD=bF;else{var bH=bG<0?1:0;if(bH)var bD=bH;else{var bI=bB<by?1:0;if(bI){var bJ=bE<by?1:0;if(bJ){var bK=bG<by?1:0,bD=bK?caml_array_get(caml_array_get(caml_array_get(bL,bB),bE),bG):bK;}else var bD=bJ;}else var bD=bI;}}}return bD;}var bV=g.toString(),bU=f.toString(),bT=e.toString();function bS(bQ,bN,bP,bO,bR){bQ.save();bQ.translate((((bN-bO|0)+by|0)-1|0)*bA,((by-1|0)-bP|0)*bz+(bN+bO|0)*bz/2);F(bR,bQ);return bQ.restore();}function bY(bW){bW.fillStyle=bV;bW.beginPath();bW.moveTo(bA,0);bW.lineTo(2*bA,bz/2);bW.lineTo(bA,bz);bW.lineTo(0,bz/2);return bW.fill();}function b0(bX){bX.beginPath();bX.moveTo(0,bz/2);bX.lineTo(bA,0);bX.lineTo(2*bA,bz/2);return bX.stroke();}function b2(bZ){bZ.fillStyle=bT;bZ.beginPath();bZ.moveTo(bA,bz);bZ.lineTo(bA,2*bz);bZ.lineTo(2*bA,1.5*bz);bZ.lineTo(2*bA,bz/2);return bZ.fill();}function b4(b1){b1.beginPath();b1.moveTo(bA,2*bz);b1.lineTo(bA,bz);b1.lineTo(2*bA,bz/2);return b1.stroke();}function b6(b3){b3.fillStyle=bU;b3.beginPath();b3.moveTo(bA,bz);b3.lineTo(bA,2*bz);b3.lineTo(0,1.5*bz);b3.lineTo(0,bz/2);return b3.fill();}function cD(b5){b5.beginPath();b5.moveTo(bA,bz);b5.lineTo(0,bz/2);b5.lineTo(0,1.5*bz);return b5.stroke();}function cC(ch,cg,b7){var b$=b7[3],b_=b7[2],b9=b7[1],b8=0,ca=by-1|0;if(!(ca<b8)){var cb=b8;for(;;){var cc=[0,by-1|0],cd=0,ce=by-1|0;if(!(ce<cd)){var cf=cd;b:for(;;){for(;;){if(0<=cc[1]&&!caml_array_get(caml_array_get(caml_array_get(cg,cb),cc[1]),cf)){cc[1]+=-1;continue;}bS(ch,cb,cc[1],cf,b9);var ci=cf+1|0;if(ce!==cf){var cf=ci;continue b;}break;}break;}}var cj=cb+1|0;if(ca!==cb){var cb=cj;continue;}break;}}var ck=0,cl=by-1|0;if(!(cl<ck)){var cm=ck;for(;;){var cn=[0,by-1|0],co=0,cp=by-1|0;if(!(cp<co)){var cq=co;b:for(;;){for(;;){if(0<=cn[1]&&!caml_array_get(caml_array_get(caml_array_get(cg,cn[1]),cm),cq)){cn[1]+=-1;continue;}bS(ch,cn[1],cm,cq,b_);var cr=cq+1|0;if(cp!==cq){var cq=cr;continue b;}break;}break;}}var cs=cm+1|0;if(cl!==cm){var cm=cs;continue;}break;}}var ct=0,cu=by-1|0;if(!(cu<ct)){var cv=ct;for(;;){var cw=[0,by-1|0],cx=0,cy=by-1|0;if(!(cy<cx)){var cz=cx;b:for(;;){for(;;){if(0<=cw[1]&&!caml_array_get(caml_array_get(caml_array_get(cg,cv),cz),cw[1])){cw[1]+=-1;continue;}bS(ch,cv,cz,cw[1],b$);var cA=cz+1|0;if(cy!==cz){var cz=cA;continue b;}break;}break;}}var cB=cv+1|0;if(cu!==cv){var cv=cB;continue;}break;}}return 0;}function cG(cF){var cE=bv.document.createElement(m.toString());if(1-(cE.getContext==bt?1:0)){cE.width=caml_mul(by*2|0,bA|0)+1|0;cE.height=caml_mul(by*2|0,bz|0)+1|0;return cE;}throw [0,bw];}function cM(cL,cH,cK){var cI=cH.getContext(bu);cI.setTransform(1,0,0,1,0,0);var cJ=cH.height;cI.clearRect(0,0,cH.width,cJ);cI.setTransform(1,0,0,1,0.5,0.5);cI.globalCompositeOperation=i.toString();cC(cI,cK,[0,bY,b2,b6]);cI.globalCompositeOperation=h.toString();cC(cI,cK,[0,b0,b4,cD]);cI.beginPath();cI.moveTo(0,by*1.5*bz);cI.lineTo(by*bA,by*2*bz);cI.lineTo(by*2*bA,by*1.5*bz);cI.lineTo(by*2*bA,by*0.5*bz);cI.stroke();return cL.drawImage(cH,0,0);}function c2(c1,c0,cU){function c4(c3){var cN=[0,0],cO=0,cP=99;if(!(cP<cO)){var cQ=cO;for(;;){var cR=ar(by),cS=ar(by),cT=ar(by);if(caml_array_get(caml_array_get(caml_array_get(cU,cR),cS),cT)){if(bM(cU,cR+1|0,cS,cT)||bM(cU,cR,cS+1|0,cT)||bM(cU,cR,cS,cT+1|0))var cV=0;else{caml_array_set(caml_array_get(caml_array_get(cU,cR),cS),cT,0);var cW=1,cV=1;}if(!cV)var cW=0;}else{if(bM(cU,cR-1|0,cS,cT)&&bM(cU,cR,cS-1|0,cT)&&bM(cU,cR,cS,cT-1|0)){caml_array_set(caml_array_get(caml_array_get(cU,cR),cS),cT,1);var cW=1,cX=1;}else var cX=0;if(!cX)var cW=0;}var cY=cW?cW:cN[1];cN[1]=cY;var cZ=cQ+1|0;if(cP!==cQ){var cQ=cZ;continue;}break;}}if(cN[1])cM(c1,c0,cU);return c2(c1,c0,cU);}var c5=[],dc=0.2,db=0,da=0;caml_update_dummy(c5,[0,[2,[0,[0,[0,function(c$){var c6=aA(c5),c7=c6[1];if(2===c7[0]){var c9=c7[1][2],c8=[1,[0,av]];c6[1]=c8;var c_=aX(c9,c8);}else var c_=0;return c_;}]],da,db]]]);var de=dc*1000,df=bv.setTimeout(caml_js_wrap_callback(function(dd){return a4(c5,0);}),de);function dh(dg){return bv.clearTimeout(df);}var di=aE(c5)[1];switch(di[0]){case 1:var dj=di[1][1]===av?(dh(0),1):0;break;case 2:var dp=di[1],dl=aw[1];bf(dp,function(dk){if(1===dk[0]&&dk[1][1]===av){aw[1]=dl;try {var dm=dh(0);}catch(dn){return 0;}return dm;}return 0;});var dj=1;break;default:var dj=0;}dj;var dq=aE(c5)[1];switch(dq[0]){case 1:var dr=bb(dq[1]);break;case 2:var ds=dq[1],dt=[0,[2,[0,ds[1],0,0]]],dv=aw[1];bf(ds,function(du){switch(du[0]){case 0:var dw=du[1];aw[1]=dv;try {var dx=c4(dw),dy=dx;}catch(dz){var dy=bb(dz);}var dA=aE(dt),dB=aE(dy),dC=dA[1];if(2===dC[0]){var dD=dC[1];if(dA===dB)var dE=0;else{var dF=dB[1];if(2===dF[0]){var dG=dF[1];dB[1]=[3,dA];dD[1][1]=[1,dG[1]];var dH=a7(dD[2],dG[2]),dI=dD[3]+dG[3]|0,dE=aC<dI?(dD[3]=0,dD[2]=a9(dH),0):(dD[3]=dI,dD[2]=dH,0);}else{dA[1]=dF;var dE=aX(dD[2],dF);}}}else var dE=d(p);return dE;case 1:var dJ=[1,du[1]],dK=aE(dt),dL=dK[1];if(2===dL[0]){var dM=dL[1][2];dK[1]=dJ;var dN=aX(dM,dJ);}else var dN=d(q);return dN;default:throw [0,b,s];}});var dr=dt;break;case 3:throw [0,b,r];default:var dr=c4(dq[1]);}return dr;}function dW(dV){var dO=cG(0),dP=cG(0);bv.document.body.appendChild(dO);var dQ=dO.getContext(bu);dQ.globalCompositeOperation=j.toString();var dR=1,dU=L(by,function(dT){return L(by,function(dS){return caml_make_vect(by,dR);});});cM(dQ,dP,dU);c2(dQ,dP,dU);return bs;}bv.onload=caml_js_wrap_callback(function(dX){if(dX===bo){var dY=event,dZ=dW(dY);dY.returnValue=dZ;var d0=dZ;}else{var d1=dW(dX);if(!(d1|0))dX.preventDefault();var d0=d1;}return d0;});C(0);return;}());
