// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && i1 === 0 && s1.last == len) {
    var s = s1.bytes;
    if (s !== null)
      s2.bytes += s1.bytes;
    else
      s2.bytes += s1.getBytes();
    s2.last += len;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] == (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] == (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] == (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:6, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  return caml_finish_formatting(f, s);
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = window.navigator?window.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
var caml_global_data = [0];
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _bs_(_gj_,_gk_)
     {return _gj_.length==1?_gj_(_gk_):caml_call_gen(_gj_,[_gk_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Assert_failure")];
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _ba_=new MlString("%d"),
     _a$_=new MlString("Pervasives.do_at_exit"),
     _a__=new MlString(""),
     _a9_=new MlString("String.blit"),
     _a8_=new MlString("String.sub"),
     _a7_=new MlString("Buffer.add: cannot grow buffer"),
     _a6_=new MlString("x"),
     _a5_=[0,new MlString("src/core/lwt.ml"),440,20],
     _a4_=[0,new MlString("src/core/lwt.ml"),443,8],
     _a3_=new MlString("Lwt.fast_connect"),
     _a2_=new MlString("Lwt.connect"),
     _a1_=new MlString("Lwt.wakeup"),
     _a0_=new MlString("Lwt.Canceled"),
     _aZ_=new MlString("iframe"),
     _aY_=new MlString("br"),
     _aX_=new MlString("textarea"),
     _aW_=new MlString("input"),
     _aV_=new MlString("\""),
     _aU_=new MlString(" name=\""),
     _aT_=new MlString("\""),
     _aS_=new MlString(" type=\""),
     _aR_=new MlString("<"),
     _aQ_=new MlString(">"),
     _aP_=new MlString(""),
     _aO_=new MlString("^error_in_anchor^"),
     _aN_=[0,new MlString("main.ml"),72,76],
     _aM_=new MlString("href"),
     _aL_=new MlString("global"),
     _aK_=new MlString("wiki"),
     _aJ_=new MlString("^error2_in_anchor^"),
     _aI_=[0,new MlString("]]"),0],
     _aH_=new MlString("[["),
     _aG_=new MlString(""),
     _aF_=[0,new MlString("]]"),0],
     _aE_=new MlString("|"),
     _aD_=new MlString("[["),
     _aC_=new MlString(""),
     _aB_=[0,new MlString("main.ml"),67,35],
     _aA_=new MlString("#text"),
     _az_=new MlString("A"),
     _ay_=new MlString("B"),
     _ax_=new MlString("BR"),
     _aw_=new MlString("DIV"),
     _av_=new MlString("H1"),
     _au_=new MlString("H2"),
     _at_=new MlString("H3"),
     _as_=new MlString("HR"),
     _ar_=new MlString("I"),
     _aq_=new MlString("P"),
     _ap_=new MlString("^"),
     _ao_=new MlString("^"),
     _an_=new MlString("\n\n"),
     _am_=[0,new MlString("//")],
     _al_=new MlString("----"),
     _ak_=new MlString("\\\\"),
     _aj_=[0,new MlString("**")],
     _ai_=new MlString("wysitype"),
     _ah_=new MlString("\n\n"),
     _ag_=new MlString(""),
     _af_=new MlString("lololo"),
     _ae_=new MlString("Enter a wikipage"),
     _ad_=new MlString(""),
     _ac_=[0,new MlString("</a>"),0],
     _ab_=new MlString("\" wysitype=\"wiki\">"),
     _aa_=new MlString("<a href=\""),
     _$_=new MlString("inserthtml"),
     ___=new MlString("http://google.ru"),
     _Z_=new MlString("Enter a link"),
     _Y_=new MlString("desc"),
     _X_=new MlString("Enter description"),
     _W_=[0,new MlString("</a>"),0],
     _V_=new MlString("\" wysitype=\"global\">"),
     _U_=new MlString("<a href=\""),
     _T_=new MlString(""),
     _S_=new MlString("inserthtml"),
     _R_=new MlString("submit"),
     _Q_=
      new
       MlString
       ("<html><body><p><b>Camelus</b><i>bactrianus</i></p></body></html>"),
     _P_=new MlString("On"),
     _O_=new MlString("inserthorizontalrule"),
     _N_=new MlString("hr"),
     _M_=new MlString("removeformat"),
     _L_=new MlString("remove format"),
     _K_=new MlString("bold"),
     _J_=new MlString("B"),
     _I_=new MlString("italic"),
     _H_=new MlString("I"),
     _G_=new MlString("formatblock"),
     _F_=new MlString("p"),
     _E_=[0,[0,new MlString("p")]],
     _D_=new MlString("formatblock"),
     _C_=new MlString("h1"),
     _B_=[0,[0,new MlString("h1")]],
     _A_=new MlString("formatblock"),
     _z_=new MlString("h2"),
     _y_=[0,[0,new MlString("h2")]],
     _x_=new MlString("formatblock"),
     _w_=new MlString("h3"),
     _v_=[0,[0,new MlString("h3")]],
     _u_=new MlString("inserthtml"),
     _t_=new MlString("link"),
     _s_=new MlString("inserthtml"),
     _r_=new MlString("link2wiki"),
     _q_=new MlString("1px black solid"),
     _p_=new MlString("5px"),
     _o_=new MlString("wikiFrame"),
     _n_=new MlString("2px blue solid"),
     _m_=new MlString("5px"),
     _l_=new MlString(""),
     _k_=[0,new MlString("main.ml"),96,17],
     _j_=new MlString("wiki_demo"),
     _i_=new MlString("2px green solid"),
     _h_=new MlString("#"),
     _g_=new MlString("wysiFrame"),
     _f_=new MlString("Main.Break");
    function _e_(s_d_){throw [0,_b_,s_d_];}
    function _bd_(x_bc_,y_bb_)
     {return caml_greaterequal(x_bc_,y_bb_)?x_bc_:y_bb_;}
    function _bj_(s1_be_,s2_bg_)
     {var
       l1_bf_=s1_be_.getLen(),
       l2_bh_=s2_bg_.getLen(),
       s_bi_=caml_create_string(l1_bf_+l2_bh_|0);
      caml_blit_string(s1_be_,0,s_bi_,0,l1_bf_);
      caml_blit_string(s2_bg_,0,s_bi_,l1_bf_,l2_bh_);
      return s_bi_;}
    function do_at_exit_bo_(param_bn_)
     {var param_bk_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_bk_)
         {var l_bl_=param_bk_[2];
          try {}catch(_bm_){}
          var param_bk_=l_bl_;
          continue;}
        return 0;}}
    caml_register_named_value(_a$_,do_at_exit_bo_);
    function _bu_(f_br_,param_bp_)
     {var param_bq_=param_bp_;
      for(;;)
       {if(param_bq_)
         {var l_bt_=param_bq_[2];
          _bs_(f_br_,param_bq_[1]);
          var param_bq_=l_bt_;
          continue;}
        return 0;}}
    function _bA_(s1_bx_,ofs1_bw_,s2_bz_,ofs2_by_,len_bv_)
     {if
       (0<=
        len_bv_&&
        0<=
        ofs1_bw_&&
        !((s1_bx_.getLen()-len_bv_|0)<ofs1_bw_)&&
        0<=
        ofs2_by_&&
        !((s2_bz_.getLen()-len_bv_|0)<ofs2_by_))
       return caml_blit_string(s1_bx_,ofs1_bw_,s2_bz_,ofs2_by_,len_bv_);
      return _e_(_a9_);}
    function _bL_(sep_bH_,l_bB_)
     {if(l_bB_)
       {var tl_bD_=l_bB_[2],hd_bC_=l_bB_[1],num_bE_=[0,0],len_bF_=[0,0];
        _bu_
         (function(s_bG_)
           {num_bE_[1]+=1;len_bF_[1]=len_bF_[1]+s_bG_.getLen()|0;return 0;},
          l_bB_);
        var
         r_bI_=
          caml_create_string
           (len_bF_[1]+caml_mul(sep_bH_.getLen(),num_bE_[1]-1|0)|0);
        caml_blit_string(hd_bC_,0,r_bI_,0,hd_bC_.getLen());
        var pos_bJ_=[0,hd_bC_.getLen()];
        _bu_
         (function(s_bK_)
           {caml_blit_string(sep_bH_,0,r_bI_,pos_bJ_[1],sep_bH_.getLen());
            pos_bJ_[1]=pos_bJ_[1]+sep_bH_.getLen()|0;
            caml_blit_string(s_bK_,0,r_bI_,pos_bJ_[1],s_bK_.getLen());
            pos_bJ_[1]=pos_bJ_[1]+s_bK_.getLen()|0;
            return 0;},
          tl_bD_);
        return r_bI_;}
      return _a__;}
    var
     _bM_=caml_sys_get_config(0)[2],
     _bN_=caml_mul(_bM_/8|0,(1<<(_bM_-10|0))-1|0)-1|0;
    function _bU_(b_bQ_,s_bO_)
     {var len_bP_=s_bO_.getLen(),new_position_bR_=b_bQ_[2]+len_bP_|0;
      if(b_bQ_[3]<new_position_bR_)
       {var new_len_bS_=[0,b_bQ_[3]];
        for(;;)
         {if(new_len_bS_[1]<(b_bQ_[2]+len_bP_|0))
           {new_len_bS_[1]=2*new_len_bS_[1]|0;continue;}
          if(_bN_<new_len_bS_[1])
           {if(!((b_bQ_[2]+len_bP_|0)<=_bN_))throw [0,_a_,_a7_];
            new_len_bS_[1]=_bN_;}
          var new_buffer_bT_=caml_create_string(new_len_bS_[1]);
          _bA_(b_bQ_[1],0,new_buffer_bT_,0,b_bQ_[2]);
          b_bQ_[1]=new_buffer_bT_;
          b_bQ_[3]=new_len_bS_[1];
          break;}}
      _bA_(s_bO_,0,b_bQ_[1],b_bQ_[2],len_bP_);
      b_bQ_[2]=new_position_bR_;
      return 0;}
    var _bV_=[0,0];
    32===_bM_;
    function _bY_(param_bX_)
     {var seq_bW_=[];
      caml_update_dummy(seq_bW_,[0,seq_bW_,seq_bW_]);
      return seq_bW_;}
    var Canceled_bZ_=[0,_a0_],current_data_b0_=[0,0],max_removed_b6_=42;
    function repr_rec_b4_(t_b1_)
     {var _b2_=t_b1_[1];
      {if(3===_b2_[0])
        {var t__b3_=_b2_[1],t___b5_=repr_rec_b4_(t__b3_);
         if(t___b5_!==t__b3_)t_b1_[1]=[3,t___b5_];
         return t___b5_;}
       return t_b1_;}}
    function repr_b8_(t_b7_){return repr_rec_b4_(t_b7_);}
    function run_waiters_cp_(waiters_b9_,state_cc_)
     {var save_b$_=current_data_b0_[1],ws_b__=waiters_b9_,rem_ca_=0;
      for(;;)
       {if(typeof ws_b__==="number")
         {if(rem_ca_)
           {var
             rem_co_=rem_ca_[2],
             ws_cn_=rem_ca_[1],
             ws_b__=ws_cn_,
             rem_ca_=rem_co_;
            continue;}}
        else
         switch(ws_b__[0])
          {case 1:
            var _cb_=ws_b__[1];
            if(rem_ca_)
             {var rem_ce_=rem_ca_[2],ws_cd_=rem_ca_[1];
              _bs_(_cb_,state_cc_);
              var ws_b__=ws_cd_,rem_ca_=rem_ce_;
              continue;}
            _bs_(_cb_,state_cc_);
            break;
           case 2:
            var
             ws1_cf_=ws_b__[1],
             _cg_=[0,ws_b__[2],rem_ca_],
             ws_b__=ws1_cf_,
             rem_ca_=_cg_;
            continue;
           default:
            var _ch_=ws_b__[1][1];
            if(_ch_)
             {var _ci_=_ch_[1];
              if(rem_ca_)
               {var rem_ck_=rem_ca_[2],ws_cj_=rem_ca_[1];
                _bs_(_ci_,state_cc_);
                var ws_b__=ws_cj_,rem_ca_=rem_ck_;
                continue;}
              _bs_(_ci_,state_cc_);}
            else
             if(rem_ca_)
              {var
                rem_cm_=rem_ca_[2],
                ws_cl_=rem_ca_[1],
                ws_b__=ws_cl_,
                rem_ca_=rem_cm_;
               continue;}}
        current_data_b0_[1]=save_b$_;
        return 0;}}
    function wakeup_cw_(t_cq_,v_ct_)
     {var t_cr_=repr_rec_b4_(t_cq_),_cs_=t_cr_[1];
      switch(_cs_[0])
       {case 1:if(_cs_[1][1]===Canceled_bZ_)return 0;break;
        case 2:
         var waiters_cv_=_cs_[1][2],state_cu_=[0,v_ct_];
         t_cr_[1]=state_cu_;
         return run_waiters_cp_(waiters_cv_,state_cu_);
        default:}
      return _e_(_a1_);}
    function append_cz_(l1_cx_,l2_cy_)
     {return typeof l1_cx_==="number"
              ?l2_cy_
              :typeof l2_cy_==="number"?l1_cx_:[2,l1_cx_,l2_cy_];}
    function cleanup_cB_(ws_cA_)
     {if(typeof ws_cA_!=="number")
       switch(ws_cA_[0])
        {case 2:
          var l1_cC_=ws_cA_[1],_cD_=cleanup_cB_(ws_cA_[2]);
          return append_cz_(cleanup_cB_(l1_cC_),_cD_);
         case 1:break;
         default:if(!ws_cA_[1][1])return 0;}
      return ws_cA_;}
    function fail_cF_(e_cE_){return [0,[1,e_cE_]];}
    function add_immutable_waiter_cJ_(sleeper_cG_,waiter_cH_)
     {var
       _cI_=
        typeof sleeper_cG_[2]==="number"
         ?[1,waiter_cH_]
         :[2,[1,waiter_cH_],sleeper_cG_[2]];
      sleeper_cG_[2]=_cI_;
      return 0;}
    var
     _cK_=[0],
     _cL_=[0,caml_make_vect(55,0),0],
     seed_cM_=caml_equal(_cK_,[0])?[0,0]:_cK_,
     l_cN_=seed_cM_.length-1,
     _cO_=0,
     _cP_=54;
    if(!(_cP_<_cO_))
     {var i_cQ_=_cO_;
      for(;;)
       {caml_array_set(_cL_[1],i_cQ_,i_cQ_);
        var _cR_=i_cQ_+1|0;
        if(_cP_!==i_cQ_){var i_cQ_=_cR_;continue;}
        break;}}
    var accu_cS_=[0,_a6_],_cT_=0,_cU_=54+_bd_(55,l_cN_)|0;
    if(!(_cU_<_cT_))
     {var i_cV_=_cT_;
      for(;;)
       {var
         j_cW_=i_cV_%55|0,
         _cX_=
          _bj_
           (accu_cS_[1],
            caml_format_int
             (_ba_,caml_array_get(seed_cM_,caml_mod(i_cV_,l_cN_))));
        accu_cS_[1]=caml_md5_string(_cX_,0,_cX_.getLen());
        var _cY_=accu_cS_[1];
        caml_array_set
         (_cL_[1],
          j_cW_,
          caml_array_get(_cL_[1],j_cW_)^
          (((_cY_.safeGet(0)+(_cY_.safeGet(1)<<8)|0)+(_cY_.safeGet(2)<<16)|0)+
           (_cY_.safeGet(3)<<24)|
           0));
        var _cZ_=i_cV_+1|0;
        if(_cU_!==i_cV_){var i_cV_=_cZ_;continue;}
        break;}}
    _cL_[2]=0;
    var pause_hook_c2_=[0,function(_c0_){return 0;}],_c1_=_bY_(0),_c4_=[0,0];
    function _c9_(param_c7_)
     {if(_c1_[2]===_c1_)return 0;
      var tmp_c3_=_bY_(0);
      tmp_c3_[1][2]=_c1_[2];
      _c1_[2][1]=tmp_c3_[1];
      tmp_c3_[1]=_c1_[1];
      _c1_[1][2]=tmp_c3_;
      _c1_[1]=_c1_;
      _c1_[2]=_c1_;
      _c4_[1]=0;
      var curr_c5_=tmp_c3_[2];
      for(;;)
       {if(curr_c5_!==tmp_c3_)
         {if(curr_c5_[4])wakeup_cw_(curr_c5_[3],0);
          var _c6_=curr_c5_[2],curr_c5_=_c6_;
          continue;}
        return 0;}}
    var null_c8_=null,undefined_c__=undefined;
    function _db_(x_c$_,f_da_){return x_c$_==null_c8_?0:_bs_(f_da_,x_c$_);}
    function _df_(x_dc_,f_dd_,g_de_)
     {return x_dc_==null_c8_?_bs_(f_dd_,0):_bs_(g_de_,x_dc_);}
    function _di_(x_dg_,f_dh_){return x_dg_==null_c8_?_bs_(f_dh_,0):x_dg_;}
    var _true_dj_=true,_false_dk_=false,array_constructor_dl_=Array;
    _bV_[1]=
    [0,
     function(e_dm_)
      {return e_dm_ instanceof array_constructor_dl_
               ?0
               :[0,new MlWrappedString(e_dm_.toString())];},
     _bV_[1]];
    function _do_(_dn_){return _dn_;}
    function _dr_(p_dp_,n_dq_){p_dp_.appendChild(n_dq_);return 0;}
    var onIE_dz_=caml_js_on_ie(0)|0;
    function handler_dy_(f_du_)
     {return _do_
              (caml_js_wrap_callback
                (function(e_ds_)
                  {if(e_ds_===undefined_c__)
                    {var _dt_=event,res_dv_=_bs_(f_du_,_dt_);
                     _dt_.returnValue=res_dv_;
                     var _dw_=res_dv_;}
                   else
                    {var res_dx_=_bs_(f_du_,e_ds_);
                     if(!(res_dx_|0))e_ds_.preventDefault();
                     var _dw_=res_dx_;}
                   return _dw_;}));}
    var window_dA_=window,document_dB_=window_dA_.document;
    function opt_iter_dE_(x_dC_,f_dD_){return x_dC_?_bs_(f_dD_,x_dC_[1]):0;}
    function createElement_dH_(doc_dG_,name_dF_)
     {return doc_dG_.createElement(name_dF_.toString());}
    function unsafeCreateElement_dK_(doc_dJ_,name_dI_)
     {return createElement_dH_(doc_dJ_,name_dI_);}
    function unsafeCreateElementEx_dV_(_type_dL_,name_dM_,doc_dO_,elt_dN_)
     {if(0===_type_dL_&&0===name_dM_)
       return createElement_dH_(doc_dO_,elt_dN_);
      if(onIE_dz_)
       {var a_dP_=new array_constructor_dl_();
        a_dP_.push(_aR_.toString(),elt_dN_.toString());
        opt_iter_dE_
         (_type_dL_,
          function(t_dQ_)
           {a_dP_.push
             (_aS_.toString(),caml_js_html_escape(t_dQ_),_aT_.toString());
            return 0;});
        opt_iter_dE_
         (name_dM_,
          function(n_dR_)
           {a_dP_.push
             (_aU_.toString(),caml_js_html_escape(n_dR_),_aV_.toString());
            return 0;});
        a_dP_.push(_aQ_.toString());
        return doc_dO_.createElement(a_dP_.join(_aP_.toString()));}
      var res_dS_=createElement_dH_(doc_dO_,elt_dN_);
      opt_iter_dE_(_type_dL_,function(t_dT_){return res_dS_.type=t_dT_;});
      opt_iter_dE_(name_dM_,function(n_dU_){return res_dS_.name=n_dU_;});
      return res_dS_;}
    function createTextarea_dZ_(_type_dY_,name_dX_,doc_dW_)
     {return unsafeCreateElementEx_dV_(_type_dY_,name_dX_,doc_dW_,_aX_);}
    function createBr_d1_(doc_d0_)
     {return unsafeCreateElement_dK_(doc_d0_,_aY_);}
    window.HTMLElement===undefined_c__;
    pause_hook_c2_[1]=
    function(param_d2_)
     {return 1===param_d2_
              ?(window_dA_.setTimeout(caml_js_wrap_callback(_c9_),0),0)
              :0;};
    function _d5_(x_d3_,f_d4_){return _bs_(f_d4_,x_d3_);}
    var Break_d6_=[0,_f_];
    function html2wiki_et_(_opt__d7_,body_em_)
     {_opt__d7_;
      var
       _d8_=10,
       n_d9_=1<=_d8_?_d8_:1,
       n_d__=_bN_<n_d9_?_bN_:n_d9_,
       s_d$_=caml_create_string(n_d__),
       _ea_=[0,s_d$_,0,n_d__,s_d$_];
      function add_str_el_(_opt__eb_,s_ed_)
       {var surr_ec_=_opt__eb_?_opt__eb_[1]:_ag_,len_ee_=s_ed_.getLen();
        try
         {var i_ef_=0;
          for(;;)
           {if(!(len_ee_<=i_ef_))
             {if
               (92===
                s_ed_.safeGet(i_ef_)&&
                i_ef_<
                (len_ee_-1|0)&&
                92===
                s_ed_.safeGet(i_ef_+1|0))
               {var _ei_=i_ef_+2|0,i_ef_=_ei_;continue;}
              if(10===s_ed_.safeGet(i_ef_))
               {var _ej_=i_ef_+1|0,i_ef_=_ej_;continue;}
              throw [0,Break_d6_,1];}
            var _eg_=0,_eh_=_eg_;
            break;}}
        catch(_ek_){if(_ek_[1]!==Break_d6_)throw _ek_;var _eh_=_ek_[2];}
        return _eh_?_bU_(_ea_,_bj_(surr_ec_,_bj_(s_ed_,surr_ec_))):0;}
      var
       childNodes_en_=body_em_.childNodes,
       _eo_=0,
       _ep_=childNodes_en_.length-1|0;
      if(!(_ep_<_eo_))
       {var i_eq_=_eo_;
        for(;;)
         {var
           _eP_=
            function(node_er_)
             {var _es_=new MlWrappedString(node_er_.nodeName);
              if(caml_string_notequal(_es_,_aA_))
               {if(caml_string_notequal(_es_,_az_))
                 {if(caml_string_notequal(_es_,_ay_))
                   {if(caml_string_notequal(_es_,_ax_))
                     {if(caml_string_notequal(_es_,_aw_))
                       {if
                         (caml_string_notequal(_es_,_av_)&&
                          caml_string_notequal(_es_,_au_)&&
                          caml_string_notequal(_es_,_at_))
                         return caml_string_notequal(_es_,_as_)
                                 ?caml_string_notequal(_es_,_ar_)
                                   ?caml_string_notequal(_es_,_aq_)
                                     ?_bU_(_ea_,_bj_(_ao_,_bj_(_es_,_ap_)))
                                     :add_str_el_(0,_bj_(html2wiki_et_(0,node_er_),_an_))
                                   :add_str_el_(_am_,html2wiki_et_(0,node_er_))
                                 :_bU_(_ea_,_al_);
                        var
                         n_eu_=(_es_.safeGet(1)-48|0)+1|0,
                         s_ev_=caml_create_string(n_eu_);
                        caml_fill_string(s_ev_,0,n_eu_,61);
                        return _bU_
                                (_ea_,_bj_(s_ev_,_bj_(html2wiki_et_(0,node_er_),_ah_)));}
                      return _bU_(_ea_,html2wiki_et_(0,node_er_));}
                    return _bU_(_ea_,_ak_);}
                  return add_str_el_(_aj_,html2wiki_et_(0,node_er_));}
                var
                 x_ex_=_do_(node_er_),
                 el_ey_=_di_(x_ex_,function(param_ew_){throw [0,_c_,_aB_];}),
                 _eI_=
                  function(s_eE_)
                   {function _eB_(_ez_){return new MlWrappedString(_ez_);}
                    function _eC_(param_eA_){throw [0,_c_,_aN_];}
                    var
                     url_eD_=
                      _d5_(_di_(el_ey_.getAttribute(_aM_.toString()),_eC_),_eB_),
                     _eF_=new MlWrappedString(s_eE_);
                    if(caml_string_notequal(_eF_,_aL_))
                     {if(caml_string_notequal(_eF_,_aK_))return _bU_(_ea_,_aJ_);
                      var _eG_=_bs_(_bU_,_ea_);
                      return _d5_(_bL_(_aG_,[0,_aH_,[0,url_eD_,_aI_]]),_eG_);}
                    return _bU_
                            (_ea_,
                             _bL_
                              (_aC_,
                               [0,
                                _aD_,
                                [0,url_eD_,[0,_aE_,[0,html2wiki_et_(0,node_er_),_aF_]]]]));},
                 _eJ_=function(param_eH_){return _bU_(_ea_,_aO_);};
                return _df_(el_ey_.getAttribute(_ai_.toString()),_eJ_,_eI_);}
              var
               _eL_=node_er_.nodeValue,
               _eN_=function(x_eK_){return [0,x_eK_];},
               _eO_=_df_(_eL_,function(param_eM_){return 0;},_eN_);
              return _eO_?_bU_(_ea_,new MlWrappedString(_eO_[1])):0;};
          _db_(childNodes_en_.item(i_eq_),_eP_);
          var _eQ_=i_eq_+1|0;
          if(_ep_!==i_eq_){var i_eq_=_eQ_;continue;}
          break;}}
      var _eR_=_ea_[2],_eS_=0,_eT_=_ea_[1];
      if(0<=_eS_&&0<=_eR_&&!((_eT_.getLen()-_eR_|0)<_eS_))
       {var r_eV_=caml_create_string(_eR_);
        caml_blit_string(_eT_,_eS_,r_eV_,0,_eR_);
        var _eW_=r_eV_,_eU_=1;}
      else
       var _eU_=0;
      if(!_eU_)var _eW_=_e_(_a8_);
      return _eW_;}
    window_dA_.onload=
    handler_dy_
     (function(param_gi_)
       {function _eY_(param_eX_){throw [0,_c_,_k_];}
        var
         body_eZ_=_di_(document_dB_.getElementById(_j_.toString()),_eY_),
         _e0_=unsafeCreateElement_dK_(document_dB_,_aZ_);
        _e0_.style.border=_i_.toString();
        _e0_.src=_h_.toString();
        _e0_.id=_g_.toString();
        _dr_(body_eZ_,_e0_);
        function _gh_(iDoc_e1_)
         {iDoc_e1_.open();
          iDoc_e1_.write(_Q_.toString());
          iDoc_e1_.close();
          iDoc_e1_.designMode=_P_.toString();
          var iWin_e2_=_e0_.contentWindow;
          _dr_(body_eZ_,createBr_d1_(document_dB_));
          function createButton_fa_(_opt__e3_,_e5_,title_e8_,action_e__)
           {var
             show_e4_=_opt__e3_?_opt__e3_[1]:_false_dk_,
             value_e6_=_e5_?_e5_[1]:0,
             _e7_=
              unsafeCreateElementEx_dV_
               ([0,_R_.toString()],0,document_dB_,_aW_);
            _e7_.value=title_e8_.toString();
            _e7_.onclick=
            handler_dy_
             (function(param_e$_)
               {iWin_e2_.focus();
                var _e9_=value_e6_?_do_(value_e6_[1].toString()):null_c8_;
                iDoc_e1_.execCommand(action_e__.toString(),show_e4_,_e9_);
                return _true_dj_;});
            _dr_(body_eZ_,_e7_);
            return _e7_;}
          createButton_fa_(0,0,_N_,_O_);
          createButton_fa_(0,0,_L_,_M_);
          createButton_fa_(0,0,_J_,_K_);
          createButton_fa_(0,0,_H_,_I_);
          _dr_(body_eZ_,createBr_d1_(document_dB_));
          createButton_fa_(0,_E_,_F_,_G_);
          createButton_fa_(0,_B_,_C_,_D_);
          createButton_fa_(0,_y_,_z_,_A_);
          createButton_fa_(0,_v_,_w_,_x_);
          var a8a7abff4_fi_=createButton_fa_(0,0,_t_,_u_);
          a8a7abff4_fi_.onclick=
          handler_dy_
           (function(param_fh_)
             {function _fc_(_fb_){return new MlWrappedString(_fb_);}
              var
               link_fe_=
                _d5_(iWin_e2_.prompt(_Z_.toString(),___.toString()),_fc_);
              function _ff_(_fd_){return new MlWrappedString(_fd_);}
              var
               link_fg_=
                _bL_
                 (_T_,
                  [0,
                   _U_,
                   [0,
                    link_fe_,
                    [0,
                     _V_,
                     [0,
                      _d5_(iWin_e2_.prompt(_X_.toString(),_Y_.toString()),_ff_),
                      _W_]]]]);
              iWin_e2_.alert(link_fg_.toString());
              iDoc_e1_.execCommand
               (_S_.toString(),_false_dk_,_do_(link_fg_.toString()));
              return _true_dj_;});
          var a97a41b38_fo_=createButton_fa_(0,0,_r_,_s_);
          a97a41b38_fo_.onclick=
          handler_dy_
           (function(param_fn_)
             {function _fk_(_fj_){return new MlWrappedString(_fj_);}
              var
               link_fl_=
                _d5_(iWin_e2_.prompt(_ae_.toString(),_af_.toString()),_fk_),
               link_fm_=
                _d5_
                 ([0,_aa_,[0,link_fl_,[0,_ab_,[0,link_fl_,_ac_]]]],
                  _bs_(_bL_,_ad_));
              iWin_e2_.alert(link_fm_.toString());
              iDoc_e1_.execCommand
               (_$_.toString(),_false_dk_,_do_(link_fm_.toString()));
              return _true_dj_;});
          _dr_(body_eZ_,createBr_d1_(document_dB_));
          var preview_fp_=createTextarea_dZ_(0,0,document_dB_);
          preview_fp_.readOnly=_true_dj_;
          preview_fp_.cols=34;
          preview_fp_.rows=10;
          preview_fp_.style.border=_q_.toString();
          preview_fp_.style.padding=_p_.toString();
          _dr_(body_eZ_,preview_fp_);
          var wikiFrame_fq_=createTextarea_dZ_(0,0,document_dB_);
          wikiFrame_fq_.id=_o_.toString();
          wikiFrame_fq_.readOnly=_true_dj_;
          wikiFrame_fq_.cols=34;
          wikiFrame_fq_.rows=10;
          preview_fp_.style.border=_n_.toString();
          preview_fp_.style.padding=_m_.toString();
          _dr_(body_eZ_,wikiFrame_fq_);
          function dyn_preview_fw_(old_text_fs_,n_fv_)
           {var text_fr_=new MlWrappedString(iDoc_e1_.body.innerHTML);
            if(caml_string_notequal(text_fr_,old_text_fs_))
             {try
               {preview_fp_.value=text_fr_.toString();
                wikiFrame_fq_.value=html2wiki_et_(0,iDoc_e1_.body).toString();}
              catch(_fu_){}
              var n_ft_=20;}
            else
             var n_ft_=_bd_(0,n_fv_-1|0);
            function _fy_(param_fx_){return dyn_preview_fw_(text_fr_,n_ft_);}
            var _fz_=0===n_ft_?0.5:0.1,t_fA_=[],_fI_=0,_fH_=0;
            caml_update_dummy
             (t_fA_,
              [0,
               [2,
                [0,
                 [0,
                  [0,
                   function(param_fG_)
                    {var t_fB_=repr_rec_b4_(t_fA_),_fC_=t_fB_[1];
                     if(2===_fC_[0])
                      {var waiters_fE_=_fC_[1][2],state_fD_=[1,[0,Canceled_bZ_]];
                       t_fB_[1]=state_fD_;
                       var _fF_=run_waiters_cp_(waiters_fE_,state_fD_);}
                     else
                      var _fF_=0;
                     return _fF_;}]],
                 _fH_,
                 _fI_]]]);
            var
             _fK_=_fz_*1000,
             id_fL_=
              window_dA_.setTimeout
               (caml_js_wrap_callback
                 (function(param_fJ_){return wakeup_cw_(t_fA_,0);}),
                _fK_);
            function _fN_(param_fM_){return window_dA_.clearTimeout(id_fL_);}
            var _fO_=repr_b8_(t_fA_)[1];
            switch(_fO_[0])
             {case 1:var _fP_=_fO_[1][1]===Canceled_bZ_?(_fN_(0),1):0;break;
              case 2:
               var sleeper_fU_=_fO_[1],data_fR_=current_data_b0_[1];
               add_immutable_waiter_cJ_
                (sleeper_fU_,
                 function(param_fQ_)
                  {if(1===param_fQ_[0]&&param_fQ_[1][1]===Canceled_bZ_)
                    {current_data_b0_[1]=data_fR_;
                     try {var _fS_=_fN_(0);}catch(_fT_){return 0;}
                     return _fS_;}
                   return 0;});
               var _fP_=1;
               break;
              default:var _fP_=0;}
            _fP_;
            var _fV_=repr_b8_(t_fA_)[1];
            switch(_fV_[0])
             {case 1:var _fW_=fail_cF_(_fV_[1]);break;
              case 2:
               var
                sleeper_fX_=_fV_[1],
                _fY_=[0,[2,[0,sleeper_fX_[1],0,0]]],
                data_f0_=current_data_b0_[1];
               add_immutable_waiter_cJ_
                (sleeper_fX_,
                 function(param_fZ_)
                  {switch(param_fZ_[0])
                    {case 0:
                      var v_f1_=param_fZ_[1];
                      current_data_b0_[1]=data_f0_;
                      try
                       {var _f2_=_fy_(v_f1_),_f3_=_f2_;}
                      catch(_f4_){var _f3_=fail_cF_(_f4_);}
                      var
                       t1_f5_=repr_b8_(_fY_),
                       t2_f6_=repr_b8_(_f3_),
                       _f7_=t1_f5_[1];
                      if(2===_f7_[0])
                       {var sleeper1_f8_=_f7_[1];
                        if(t1_f5_===t2_f6_)
                         var _f9_=0;
                        else
                         {var _f__=t2_f6_[1];
                          if(2===_f__[0])
                           {var sleeper2_f$_=_f__[1];
                            t2_f6_[1]=[3,t1_f5_];
                            sleeper1_f8_[1][1]=[1,sleeper2_f$_[1]];
                            var
                             waiters_ga_=append_cz_(sleeper1_f8_[2],sleeper2_f$_[2]),
                             removed_gb_=sleeper1_f8_[3]+sleeper2_f$_[3]|0,
                             _f9_=
                              max_removed_b6_<removed_gb_
                               ?(sleeper1_f8_[3]=
                                 0,
                                 sleeper1_f8_[2]=
                                 cleanup_cB_(waiters_ga_),
                                 0)
                               :(sleeper1_f8_[3]=removed_gb_,sleeper1_f8_[2]=waiters_ga_,0);}
                          else
                           {t1_f5_[1]=_f__;
                            var _f9_=run_waiters_cp_(sleeper1_f8_[2],_f__);}}}
                      else
                       var _f9_=_e_(_a2_);
                      return _f9_;
                     case 1:
                      var
                       _gc_=[1,param_fZ_[1]],
                       t_gd_=repr_b8_(_fY_),
                       _ge_=t_gd_[1];
                      if(2===_ge_[0])
                       {var waiters_gf_=_ge_[1][2];
                        t_gd_[1]=_gc_;
                        var _gg_=run_waiters_cp_(waiters_gf_,_gc_);}
                      else
                       var _gg_=_e_(_a3_);
                      return _gg_;
                     default:throw [0,_c_,_a5_];}});
               var _fW_=_fY_;
               break;
              case 3:throw [0,_c_,_a4_];
              default:var _fW_=_fy_(_fV_[1]);}
            return _fW_;}
          dyn_preview_fw_(_l_,0);
          return 0;}
        _db_(_e0_.contentDocument,_gh_);
        return _false_dk_;});
    do_at_exit_bo_(0);
    return;}
  ());
